#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <math.h>
#include <string.h>

void gotoxy(short x, short y){
	COORD coords={x,y};
	SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE),coords);
}

short wherex(void){
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE),&csbi);
	return csbi.dwCursorPosition.X;
}

short wherey(void){
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE),&csbi);
	return csbi.dwCursorPosition.Y;
}

int even(int v){
	return ((fmod((double)v,2.0)==0.0)?1:0);
}

char rotate(void){
	static int p=0;
	char *c="-\\|/";
	if(++p==4){
		p=0;
	}
	return c[p];
}

int main(int argc, char *argv[]){
	FILE *fquelle=NULL, *fziel=NULL;
	char ch=0;
	char *line=NULL;
	int lengths=0, tabs=0, quotes=0, brackets=0, errors=0;
	printf("Log2Csv - EXPERIMENTELLE Version (Build %s %s)\n(C) Copyright 2003..04 by Steffen Lange\n",__DATE__,__TIME__);
	if(argc!=3){
		printf("FEHLER:\tAufruf mit Parametern 'Quelldatei' (Logfile) und 'Zieldatei' (CSV-Datei)\n\t%s <quelle.log> <ziel.csv>\n",argv[0]);
		exit(0);
	}
	fquelle=fopen(argv[1],"rt");
	fziel=fopen(argv[2],"w+t");
	if(fquelle!=NULL&&fziel!=NULL){
		printf("Konvertiere Logfile '%s' nach CSV-Datei '%s':\n\n",argv[1],argv[2]);
		line=(char *)calloc(65536,sizeof(char));
		memset((char *)line,0,65536);
		while((ch=(char)getc(fquelle))!=EOF){
			if(ch=='"'){
				quotes++;
			}
			else if((ch=='['||ch==']')&&even(quotes)){
				brackets++;
			}
			else if(ch==' '&&even(quotes)&&even(brackets)){
				tabs++;
				ch=';';
			}
			line[lengths]=ch;
			lengths++;
			if(ch=='\n'){
				printf("%c",rotate());
				gotoxy(0,wherey());
				if(tabs==8&&quotes==6&&brackets==2){
					fputs(line,fziel);
				}
				else{
					errors++;
				}
				lengths=tabs=quotes=brackets=0;
				memset((char *)line,0,65536);
			}
		}
		free(line);
		printf("Fehlerhafte Logfile-Zeilen: %d !!!\n",errors);
	}
	if(fquelle!=NULL){
		fclose(fquelle);
	}
	else{
		printf("\nFEHLER:\tKann Quelldatei '%s' (Logfile) nicht lesen!\n",argv[1]);
	}
	if(fziel!=NULL){
		fclose(fziel);
	}
	else{
		printf("\nFEHLER:\tKann Zieldatei '%s' (CSV-Datei) nicht schreiben!\n",argv[2]);
	}
	return 0;
}
